#ifndef MAX7219_H
#define	MAX7219_H
//------------------------Dot Matrix LED  Driver--------------------------------
#include <string.h>
#include "../Soft_SPI/Soft_SPI.h"
#include "MAX7219_Prototypes.h"
//------------------------------------------------------------------------------
void MAX7219_init()
{
  SPI_init();
  
  MAX7219_write(DECODE_MODE_REG, DECODE_ALL);    
  MAX7219_write(INTESITY_REG, BRIGHTNESS);     
  MAX7219_write(SCAN_LIMIT_REG, SCAN_LOW_NIBBLE);     
  MAX7219_write(SHUTDOWN_REG, NORMAL_OPERATION);
}
//------------------------------------------------------------------------------
void MAX7219_write(char reg, char data)
{
  CS = 0; 
  
  SPI_write(reg); 
  SPI_write(data); 
  
  CS = 1;
}
//------------------------------------------------------------------------------
void MAX7219_displayNum(signed int number)
{   
  char strNum[15]; 
  sprintf(strNum,"%4i",number);
  
  for(char pos = 0; pos < strlen(strNum); pos++)
  {   
    char i = strNum[pos];  
    MAX7219_write(pos+1, getDigit(i));
  }
}
//------------------------------------------------------------------------------
char getDigit(char asciiChar)
{
    char digit = 0;
    
    if(asciiChar >= '0' && asciiChar <= '9') 
    {
        digit = asciiChar;
    }
    else
        if(asciiChar == '-')
        {
            digit = 0x0A;       //0x0A - minus symbol see MAX7219 data-sheet
        }
        else
            if(asciiChar == ' ')
            {
                digit = 0x0F;  //0x0F - blank. used for leading zero suppression
            }
    
    return digit;
}
//------------------------------------------------------------------------------
#endif	